<template>
  <v-select
    v-model="internalValue"
    :items="items"
    item-text="text"
    item-value="key"
    :rules="rules"
    :clearable="clearable"
  >
    <template #label>
      <span>
        {{ internalLabel }}
        <span v-if="required" class="red--text text--darken-2"> *</span>
      </span>
    </template>
    <template v-if="wikiEntry" #append-outer>
      <GIconBtn
        i18n="form.showInformation"
        icon="mdi-information"
        color="grey darken-1"
        small
        small-btn
        @click="toggleInformation(wikiEntry)"
      />
    </template>
  </v-select>
</template>

<script>
import { DCCXMLElement } from "@d-ptb/dcc-js";
import { generateWikiUri } from "assets/util/general";
import { getRules } from "~/components/App/Validation";
import GIconBtn from "@/components/App/Common/GIconBtn";

export default {
  name: "DccSelect",
  components: { GIconBtn },
  props: {
    value: Object,
    label: String,
    i18n: String,
    items: Array,
    validate: String,
    clearable: Boolean,
    wikiEntry: String,
  },
  computed: {
    internalValue: {
      get() {
        return this.value ? this.value._text : "";
      },
      set(val) {
        if (val) {
          if (this.value) {
            this.value._text = val;
            this.$emit("input", this.value);
          } else {
            this.$emit("input", new DCCXMLElement({ _text: val }));
          }
        } else {
          this.$emit("input", null);
        }
      },
    },
    internalLabel() {
      return this.label ?? this.$t(this.i18n);
    },
    rules() {
      return getRules(this, this.internalLabel, this.validate);
    },
    required() {
      return this.validate === "required";
    },
  },
  methods: {
    toggleInformation(wikiEntry) {
      if (wikiEntry) {
        window.open(generateWikiUri(wikiEntry), "_blank").focus();
      }
    },
  },
};
</script>
